
; add model procedures here

;define variables
breeds [person gunshop blackmarket]
patches-own [food-density temperature]
turtles-own [status other-gunshop skeleton-timer gun-demand guns life gun-competence aggression marksmanship stature openness intelligence]
globals [time tick gun-security homicides police-deaths aggressive-deaths non-aggressive-deaths total-guns gga bga  ilg iig iigbga ilggga illegal-guns legal-guns guns-destroyed this-tick-deaths injured total-assaults initial-aggressives initial-non-aggressives]

to go 
ask person [mouse-action]
set time time + 1
set tick tick + 1
if tick = 10 [set tick 1 set this-tick-deaths 0]
if time = end-experiment [stop]
person-colours
ask person [shopping]
ask person [blackmarketing]
ask person [attack?]

reveal-gun-supply
move
set total-guns legal-guns + illegal-guns
do-plot
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SUBROUTINES

to setup
  ca 
     set total-guns initial-legal-guns +  initial-illegal-guns + no-of-police
     set legal-guns initial-legal-guns + no-of-police 
     set illegal-guns  initial-illegal-guns
  set-default-shape person "skeleton"
  create-custom-gunshop legal-gun-availability [set shape "gunshop";building store"
                          set xcor random  screen-size-x
                          set ycor random screen-size-y
                          if legal-gun-availability > initial-legal-guns [set initial-legal-guns legal-gun-availability]
                          set guns int(initial-legal-guns / legal-gun-availability)
                          set guns-of  random-one-of gunshop guns +  initial-legal-guns mod legal-gun-availability
                          set gga legal-gun-availability
                          if (gga = 0) [set gga 0.5]
                          set ilg initial-legal-guns
                          if (ilg = 0) [set ilg 0.5]
                          set ilggga  int ((ilg / gga )* 1.4)
                          if (ilggga = 0) [set ilggga 1]
                          set color scale-color red guns ilggga  0
                          ]
     create-custom-blackmarket illegal-gun-availability [set shape "blackmarket" ;building store"
                          set xcor random  screen-size-x
                          set ycor random screen-size-y   
                          if illegal-gun-availability > initial-illegal-guns [set initial-illegal-guns illegal-gun-availability]                   
                          set guns int (initial-illegal-guns / illegal-gun-availability)
                          set guns-of  random-one-of blackmarket guns +  initial-illegal-guns mod illegal-gun-availability
                          set bga illegal-gun-availability
                          if (bga = 0) [set bga 1]
                          set iig initial-illegal-guns
                          if (iig = 0) [set iig 1]
                          set iigbga int ((iig / bga) * 1.4)
                          if (iigbga = 0) [set iigbga 1]
                          ;set color scale-color black guns int ((iig / bga) * 1.4)  0
                          set color scale-color black guns iigbga  0
                           
                           ]
  create-custom-person no-of-citizens [set status 0
                        if (random 101  < demand-for-guns) [set gun-demand 1]
                        set openness random-normal 20 4
                        ;set openness 100
                         set intelligence random-normal mean-intelligence intelligence-spread
                        set gun-competence random-normal mean-gun-competence gun-competence-spread
                        set aggression random-normal mean-aggression aggression-spread
                        set marksmanship aggression * gun-competence
                        set shape "person"
                        ;set color 18
                        set color scale-color black aggression 100 0 
                         fd (random screen-edge-x)
                         set life 100
                         if (aggression > aggression-threshold) [set stature "baddy"]
                         if (aggression <= aggression-threshold) [set stature "goody"]
                         set initial-aggressives count person with [stature = "baddy"]
                         set initial-non-aggressives count person with [stature = "goody"]
                        ] 
      create-custom-person no-of-police [set status 1
                         set openness random-normal 30 5
                        set shape "person police"
                        set gun-competence random-normal police-gun-competence 5
                        set aggression random-normal police-mean-aggression police-aggression-spread
                        ;set aggression 20
                        set marksmanship aggression * gun-competence
                        set color 94
                        set guns 1
                         fd (random screen-edge-x)
                         set life 100
                         set stature "police"
                         ] 
    
    ask patches [set pcolor green]
  
    end

;;;;;;;;;;;
to inject
;only allow one Jesus
if (count person with [status = 5] > 0) [stop]
create-custom-person 1 [set status 5
                        set gun-demand 0
                        set gun-competence random-normal mean-gun-competence gun-competence-spread
                        set aggression 0
                        set marksmanship aggression * gun-competence
                        set shape "person"
                        ;set color 18
                        set color violet 
                         fd (random screen-edge-x)
                         set life 100
                         if (aggression > aggression-threshold) [set stature "baddy"]
                         if (aggression <= aggression-threshold) [set stature "goody"]
                        
                        ]
end

to mouse-action
if (mouse-down? and count person-at mouse-xcor mouse-ycor > 0 and stature-of one-of person-at mouse-xcor mouse-ycor != "police" and count person with [status = 3] < 1) 
;if (mouse-down? ) 

;(distancexy-nowrap mouse-xcor mouse-ycor ) < 20)
  [ 
  if (stature = "baddy") [set legal-guns legal-guns + guns set illegal-guns illegal-guns - guns]
   set status-of one-of person-on patch-at mouse-xcor mouse-ycor  3
  set aggression aggression - 10 
  if (aggression <= aggression-threshold) [set stature "goody"]
  ]

end
to person-colours
 ask person [                                    
 if (status = 0) [citizen]             
 if (status =  1) [police]    
 if (status =  2) [skeleton]  
 ;status = 3 or 4 is persuader   
 if ( status = 3 or status = 4) [set color magenta ]
; status = 5 is Jesus
  if ( status = 5) [set color violet ]
]
end

to reveal-gun-supply
 set iig initial-illegal-guns
 if (iig = 0) [set iig 0.5]
set bga illegal-gun-availability
if (bga = 0 ) [set bga 0.5]
set iigbga int ((iig / bga) * 1.4)
if (iigbga = 0) [set iigbga 1]
ask blackmarket [set color scale-color black guns iigbga  0]



set ilg initial-legal-guns
if (ilg = 0) [set ilg 0.5]
set gga legal-gun-availability 
if (gga = 0) [set gga 0.5]
set ilggga  int ((ilg / gga )* 1.4)
if (ilggga = 0) [set ilggga 1]
ask gunshop [set color scale-color red guns ilggga 0]
end




to shopping
;ie shopping for LEGAL GUNS  
if (count gunshop-here > 0 and  stature =  "baddy"  and gun-demand  > 0 and guns-of one-of gunshop-here > 0 and gun-elegibility-criterion = "none")
 [
 ;nb must leave the following commands out because of problems with reporting legal  & illegal guns
  ;set guns-of one-of person-here with [stature = "baddy" and gun-demand  > 0] guns-of one-of person-here + 1 
   ;   set  guns-of one-of gunshop-here guns-of one-of gunshop-here - 1
    ] 
if (count gunshop-here > 0 and  stature =  "goody"  and gun-demand  > 0 and guns-of one-of gunshop-here > 0 )
      [
      if (gun-elegibility-criterion = "aggression" and aggression >= aggression-threshold) [stop]
      if (gun-elegibility-criterion = "gun-competence" and gun-competence < gun-competence-threshold) [stop]
     if (gun-elegibility-criterion = "both" and ( aggression >= aggression-threshold or gun-competence < gun-competence-threshold ))[stop]
      set guns-of one-of person-here with [stature = "goody" and gun-demand  > 0] guns-of one-of person-here + 1 
      set  guns-of one-of gunshop-here guns-of one-of gunshop-here - 1
      ]                          

 ;"sell" gun to gunshop 

 ;if (count gunshop-here > 0  and status-of one-of person-here = 3 and guns-of one-of person-here > 0) [set guns-of one-of person-here guns-of one-of person-here - 1
  ;  set  guns-of one-of gunshop-here guns-of one-of gunshop-here + 1]                                       

;persuaded who no longer have a demand for guns sell them to the gunshop (only persuaded would have guns without the demand
if (count gunshop-here > 0  and stature-of one-of person-here = "goody" and guns-of one-of person-here > 0 and gun-demand = 0 ) 
  [set guns-of one-of person-here guns-of one-of person-here - guns
  set  guns-of one-of gunshop-here guns-of one-of gunshop-here + guns]                                       

 ;goody sells extra gun
 if (count gunshop-here > 0  and stature-of one-of person-here = "goody" and guns-of one-of person-here > 1) 
  [set guns-of one-of person-here guns-of one-of person-here - 1
  set  guns-of one-of gunshop-here guns-of one-of gunshop-here + 1]                                       

;police sells extra gun
if (count gunshop-here > 0 and stature-of one-of person-here = "police" and  guns-of one-of person-here > 1 and illegal-guns-destroyed? = false) 
  [ set guns-of one-of person-here guns-of one-of person-here - 1
  set guns-of one-of gunshop-here guns-of one-of gunshop-here + 1
  ]

;police destroy guns
if (count gunshop-here > 0 and stature-of one-of person-here = "police" and  guns-of one-of person-here > 1 and illegal-guns-destroyed? = true) 
[set guns-of one-of person-here guns-of one-of person-here - 1 set total-guns total-guns - 1
set guns-destroyed guns-destroyed + 1
;NB "legal-guns" is used here because they have been cconverted from illegal guns
set legal-guns legal-guns - 1
] 

end

to blackmarketing
;if (count blackmarket-here > 0  and stature = "baddy" and aggression >= aggression-threshold and gun-demand  > 0 and guns-of one-of blackmarket-here > 0 )           

if (count blackmarket-here > 0  and stature = "baddy" and gun-demand  > 0 and guns-of one-of blackmarket-here > 0 )           
      [ 
        
      
      set guns-of one-of person-here with [stature = "baddy"] guns-of one-of person-here + 1 
      set  guns-of one-of blackmarket-here guns-of one-of blackmarket-here - 1
      ]                          
  ;"sell" gun to blackmarket
    if (count blackmarket-here > 0  and stature-of one-of person-here = "baddy" and guns-of one-of person-here > 1) [set guns-of one-of person-here guns-of one-of person-here - 1
    set  guns-of one-of blackmarket-here guns-of one-of blackmarket-here + 1]                                       
end


to attack?
if (count other-person-here  = 0) [stop]
if (life < 1) [stop]
; persuaders  persuade:

if (stature != "police" and status-of one-of other-person-here = 3 and  openness > (random 101 + 15))

      [ set status 3 set aggression aggression - 10 set gun-demand 0 
        if (aggression <= aggression-threshold) 
            [if (stature = "baddy") [ set stature "goody" 
                if (guns > 1)  [set legal-guns legal-guns + guns set illegal-guns illegal-guns - guns ]
             ]
        ] stop]
if (stature != "police" and status-of one-of other-person-here = 5 and  openness > (random 101 + 5))

    [ set status 4 set aggression aggression - 20 set gun-demand 0 
       if (aggression <= aggression-threshold) 
           [if (stature = "baddy") [ set stature "goody"
           if (guns > 1) [set legal-guns legal-guns + guns set illegal-guns illegal-guns - guns]
           ]
      ] stop]

if (stature != "police" and status-of one-of other-person-here = 4 and  openness > (random 101 + 5))
    [ set status 4 set aggression aggression - 20 set gun-demand 0 
      if (aggression <= aggression-threshold) 
      [if (stature = "baddy") [ set stature "goody"
      if (guns > 1) [set legal-guns legal-guns + guns set illegal-guns illegal-guns - guns]
      ]
      ] stop]


if (status = 0 and status-of one-of other-person-here = 0 and  sqrt  (abs (aggression * aggression-of one-of other-person-here )) < attack-threshold) [stop]
if (status = 1 and status-of one-of other-person-here = 0 and  sqrt ( abs (aggression * aggression-of one-of other-person-here )) < attack-threshold) [stop]
if (stature = "baddy"  and guns = 0 and stature-of one-of other-person-here = "goody") [stop]
if (stature = "baddy"  and guns = 0 and stature-of one-of other-person-here = "police") [stop]

 if (stature = "baddy" and (intelligence /  4)> ((initial-legal-guns / no-of-citizens) * 100)) [stop]

if (stature = "goody"  and stature-of one-of other-person-here = "goody")[stop]
if (stature = "goody"  and stature-of one-of other-person-here = "police")[stop]
if (stature = "police"  and stature-of one-of other-person-here = "police")[stop]
;dead people can't do anything;     
   if (status = 2) [stop]    

if (marksmanship <= marksmanship-of one-of other-person-here and guns-of one-of other-person-here > 0) 
[

set life life - firepower
set total-assaults total-assaults + 1 


;NB error machinery is reporting no person here - need to rethink otherwise will get reporting errors
;next line prevents error and does not solve problem
;if (count person-here = 0 or count other-person-here = 0) [stop]
if (life < 1) 
[

; twas a "baddy" that died "goody" that confiscated gun:
 if (stature = "baddy"  and guns > 0 and stature-of one-of other-person-here = "goody") 
 [ set guns-of one-of other-person-here guns + guns 
 set this-tick-deaths this-tick-deaths + 1 
 set  status 2 
 set homicides homicides + 1  
 set illegal-guns illegal-guns - guns 
 set legal-guns legal-guns  + guns 
 set aggressive-deaths aggressive-deaths + 1 
 set guns guns - guns 
 stop]
 
 if (stature = "baddy"  and guns < 1 and stature-of one-of other-person-here = "goody") 
[ set this-tick-deaths this-tick-deaths + 1 
set status 2 
set homicides homicides + 1   
set aggressive-deaths aggressive-deaths + 1 
stop]


; twas a "baddy" that died "baddy" that stole gun:
if ( stature = "baddy" and guns > 0 and stature-of one-of other-person-here = "baddy") 
[set guns-of one-of other-person-here guns + guns 
set this-tick-deaths this-tick-deaths + 1 
set status 2 
set homicides homicides + 1  
 set aggressive-deaths aggressive-deaths + 1 
 set guns guns - guns 
 stop]

if ( stature = "baddy" and  guns < 1 and stature-of one-of other-person-here = "baddy") 
[ set this-tick-deaths this-tick-deaths + 1 
set status 2 
set homicides homicides + 1   
set aggressive-deaths aggressive-deaths + 1 
stop]

;twas a goody that died and baddy that stole gun:
if (stature = "goody" and guns > 0 and stature-of one-of other-person-here = "baddy"   ) 
[set guns-of one-of other-person-here guns + guns 
set this-tick-deaths this-tick-deaths + 1 
set status 2 
set homicides homicides + 1 
set illegal-guns illegal-guns + guns 
set legal-guns legal-guns - guns 
set non-aggressive-deaths non-aggressive-deaths + 1 
set guns guns - guns 
stop] 

if (stature = "goody" and guns < 1 and stature-of one-of other-person-here = "baddy"   ) [ 
set this-tick-deaths this-tick-deaths + 1 
set status 2 
set homicides homicides + 1  
set non-aggressive-deaths non-aggressive-deaths + 1 
stop] 
 
;policeman dies baddy steals gun:
if (stature = "police" and stature-of one-of other-person-here = "baddy"   ) 
[set guns-of one-of other-person-here guns + guns 
set this-tick-deaths this-tick-deaths + 1 
set status 2 
set homicides homicides + 1  
set illegal-guns illegal-guns + guns 
set legal-guns legal-guns - guns 
set police-deaths 
police-deaths + 1 
stop]

;baddy dies policeman confiscates gun;
if (stature = "baddy" and guns > 0 and stature-of one-of other-person-here = "police"   ) 
[set guns-of one-of other-person-here guns + guns 
set this-tick-deaths this-tick-deaths + 1 
set status 2 
set homicides homicides + 1 
set illegal-guns illegal-guns -  guns 
set legal-guns legal-guns + guns 
set aggressive-deaths aggressive-deaths + 1 
set guns guns - guns 
stop]

if (stature = "baddy" and guns < 1 and stature-of one-of other-person-here = "police"   ) 
[ set this-tick-deaths this-tick-deaths + 1 
set status 2 set homicides homicides + 1  
set aggressive-deaths 
aggressive-deaths + 1 
stop]

;set status 2 
;set this-tick-deaths this-tick-deaths + 1
]
]
end

to  move
ask person [
if (status = 2) [stop]
;show status
set heading (random 360) 
fd 1]
end

to citizen
set shape "person"
;set color 4 ;gray

if (show-citizen-parameter = "aggression" )  [set color scale-color black aggression 120 0 ]
if (show-citizen-parameter = "life" )  [set color scale-color red life 120 0 ]
if (show-citizen-parameter = "marksmanship" )  [set color scale-color yellow marksmanship 5000 0 ]
if (show-citizen-parameter =  "gun-competence")  [set color scale-color blue gun-competence 120 0]
if (show-citizen-parameter =  "guns")  [set color scale-color orange guns 3 0]

end

to police
set shape "person police"
set color 94
end

to skeleton 
set skeleton-timer skeleton-timer + 1
if (skeleton-timer > 100) [die]
set shape "skeleton"
set color 94
end

;to setup-plot
 ; set-current-plot "Population distribution"
  ;set-plot-x-range (- screen-edge-x) screen-edge-x
  ;set-plot-x-range (0) 140
  ;set-plot-y-range 0 count bug


;set-current-plot "Population"
  ;set-plot-x-range (- screen-edge-x) screen-edge-x
 ;set-plot-x-range (0) 100
;set-plot-y-range 0 count bug


;end
to do-plot
 set-current-plot "Guns and Moses"
  ;set-plot-x-range (- screen-edge-x) screen-edge-x
  set-plot-x-range (0) 100
  set-current-plot-pen "homicide rate"
; if (homicides > 0) [set-plot-y-range 0 ]
 if (homicides > 0 and tick = 9) [plot this-tick-deaths] 
 ;if (homicides > 0 ) [plot this-tick-deaths]  
;  if (homicides > 0) [set-plot-y-range 0 homicides]
 ;  if (homicides > 0) [plot homicides]
 ; if (homicides > 0 and time > 0) [plot homicides / time]
 
  set-plot-x-range (0) 100
  set-current-plot-pen "Armed aggressives"
 ;if (homicides > 0) [set-plot-y-range 0 count person with [status = 1] ]
 if (homicides > 0  and tick = 9) [plot count person with [aggression > aggression-threshold and guns > 0 and status = 0] ]
 set-current-plot-pen "Armed non-aggressives"
 if (homicides > 0  and tick = 9) [plot count person with [aggression <= aggression-threshold and guns > 0 and status = 0] ]
 
 
  ;set-histogram-num-bars 100
 ;h;istogram-from bug [smrs]
 
set-current-plot "Aggressive vs non-aggressive deaths"

if (non-aggressive-deaths > 0 and aggressive-deaths > 0 )
          [
          plot aggressive-deaths
          set-plot-x-range (0) non-aggressive-deaths 
          ] 


 end

@#$#@#$#@
GRAPHICS-WINDOW
593
10
975
341
15
12
12.0
1
10
1
1
1
0

CC-WINDOW
5
583
986
678
Command Center

BUTTON
5
12
72
45
setup
setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
77
13
140
46
go
go
T
1
T
OBSERVER
NIL
NIL

SLIDER
371
61
549
94
legal-gun-availability
legal-gun-availability
0
20
5
1
1
NIL

MONITOR
290
343
449
392
Unarmed non-aggressives
count person with [status = 0 and aggression < aggression-threshold and guns = 0]
0
1

MONITOR
290
396
449
445
Unarmed aggressives
count person  with [status = 0 and aggression >= aggression-threshold and guns = 0]
0
1

SLIDER
6
66
172
99
no-of-citizens
no-of-citizens
0
600
300
50
1
NIL

SLIDER
194
177
363
210
no-of-police
no-of-police
0
100
1
1
1
NIL

MONITOR
144
343
289
392
Armed non-aggressives
count person with [status = 0 and aggression < aggression-threshold and guns > 0 ]
0
1

MONITOR
140
396
289
445
Armed aggressives
count person with [status = 0 and aggression >= aggression-threshold and guns > 0]
0
1

SLIDER
4
105
183
138
mean-gun-competence
mean-gun-competence
0
100
50
1
1
%

SLIDER
191
214
369
247
police-gun-competence
police-gun-competence
0
100
50
1
1
%

SLIDER
370
97
548
130
illegal-gun-availability
illegal-gun-availability
0
20
20
1
1
NIL

PLOT
393
446
712
566
Guns and Moses
NIL
NIL
0.0
10.0
0.0
10.0
true
true
PENS
"homicide rate" 1.0 0 -65536 true
"Armed aggressives" 1.0 0 -16777216 true
"Armed non-aggressives" 1.0 0 -16776961 true

SLIDER
193
137
362
170
demand-for-guns
demand-for-guns
0
100
99
1
1
%

MONITOR
282
513
376
562
total homicides
homicides
0
1

MONITOR
451
397
592
446
NIL
aggressive-deaths
0
1

MONITOR
452
342
590
391
NIL
non-aggressive-deaths
0
1

MONITOR
279
458
373
507
NIL
police-deaths
0
1

SLIDER
5
177
180
210
mean-aggression
mean-aggression
0
100
49
1
1
NIL

SLIDER
371
137
543
170
initial-legal-guns
initial-legal-guns
0
200
200
1
1
NIL

SLIDER
372
176
544
209
initial-illegal-guns
initial-illegal-guns
0
200
31
1
1
NIL

SWITCH
370
254
546
287
illegal-guns-destroyed?
illegal-guns-destroyed?
1
1
-1000

MONITOR
208
512
277
561
NIL
total-guns
0
1

BUTTON
148
12
230
45
go once
go
NIL
1
T
OBSERVER
NIL
NIL

MONITOR
106
456
182
505
NIL
legal-guns
0
1

MONITOR
192
458
269
507
NIL
illegal-guns
0
1

MONITOR
102
512
203
561
NIL
guns-destroyed
0
1

MONITOR
13
513
97
562
NIL
time
0
1

SLIDER
805
351
977
384
end-experiment
end-experiment
0
1000
300
10
1
NIL

SLIDER
6
254
174
287
aggression-threshold
aggression-threshold
0
100
50
1
1
NIL

SLIDER
10
297
176
330
attack-threshold
attack-threshold
0
100
50
1
1
NIL

SLIDER
371
215
543
248
firepower
firepower
0
100
25
1
1
NIL

SLIDER
4
216
176
249
aggression-spread
aggression-spread
1
10
10
1
1
NIL

SLIDER
2
141
183
174
gun-competence-spread
gun-competence-spread
0
10
10
1
1
NIL

MONITOR
12
462
102
511
NIL
total-assaults\n
0
1

SLIDER
191
256
367
289
police-mean-aggression
police-mean-aggression
0
100
50
1
1
NIL

SLIDER
190
296
367
329
police-aggression-spread
police-aggression-spread
0
10
5
1
1
NIL

PLOT
720
446
967
569
Aggressive vs non-aggressive deaths
non-aggressives
aggressives
0.0
10.0
0.0
10.0
true
false

SLIDER
376
23
558
56
gun-competence-threshold
gun-competence-threshold
0
100
50
1
1
NIL

CHOOSER
375
289
542
334
gun-elegibility-criterion
gun-elegibility-criterion
"gun-competence" "non-aggression" "both" "none"
2

MONITOR
7
396
139
445
NIL
initial-aggressives
0
1

MONITOR
7
345
141
394
NIL
initial-non-aggressives
0
1

CHOOSER
624
347
797
392
show-citizen-parameter
show-citizen-parameter
"aggression" "gun-competence" "marksmanship" "guns" "life"
0

MONITOR
802
389
859
438
no. alive
count person with  [status < 2 or status > 2]
0
1

BUTTON
238
11
361
44
inject the Persuader
inject
NIL
1
T
OBSERVER
NIL
NIL

MONITOR
624
392
749
441
no. of persuaders
count person with [status = 3 or status = 4 or status = 5]
0
1

BUTTON
891
395
973
428
defaults
set no-of-citizens 300
NIL
1
T
OBSERVER
NIL
NIL

SLIDER
192
55
364
88
mean-intelligence
mean-intelligence
0
200
100
10
1
NIL

SLIDER
191
96
366
129
intelligence-spread
intelligence-spread
0
10
2
1
1
NIL

@#$#@#$#@

WHAT IS IT?
----------- 
How does one go about trying to reduce gun-related crime in society? This model shows that figuring out the way forward is not at all simple because society is a complex system. Both the pro and anti-gun lobbies have been known to fall into single-factor thinking and other fallacies in trying to win over public opinion. Classic examples are "guns do not kill people, people kill people" and "ban guns and the crime rate will go down." Both claims downplay important ingredients in the criminal mix. Guns _and_ human aggression and a lot else besides affect crime. There are no quick fixes. In this model the user can play the role of the State or social engineer and even God to see what effect varying about a dozen factors and sub-factors has on homicide levels. Even with all these factors I hesitate to call "Guns and Moses" a model because it is too simple. Perhaps  "dynamic illustration" would be better. The point is that if single-factor thinking is so demonstrably inadequate here, how much more so is it in trying to understand society and how to fix its problems.

HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.

There are two kinds of agents - citizens and gunshops. Citizens acquire guns from gunshops.  Gunshops are of two sorts - legal and illegal (the blackmarket).  Two citizens that land on the same patch will engage each other. The outcome of their engagement depends on several variables as outlined in the next section. 


HOW TO USE IT
-------------

Pretend you are the state or a social engineer. Your job is to try and reduce the homicide levels in a population of citizens by  moving the various sliders. There are some trivial (and impractical solutions in real life) such as eliminating all weapons. Make the task challenging for  yourself by allowing a supply of legal and illegal guns. 
Here are descriptions of the sliders: 

mean-gun-competence - ability to use a gun follows a normal curve. This slider sets the mean.

gun-competence-spread - sets the standard deviation.

mean-agression - how trigger-happy the population is follows a normal curve.

aggression-threshold - determines who are baddies and goodies. If a citizen's aggression is greater than this threshold it is a baddy. If it is less than or equal to this threshold it is a goody. Goodies never attack goodies or baddies without a gun. Baddies will attack anyone.

attack-threshold - if the square root of the product of the aggression of the two citizen is equal to or above this threshold then the citizens will attack each other. The citizen with the greater product of gun-competence (ability to use a gun) and aggression (willingness to use it) is the winner. Bad citizens can steal guns from their victims. Good citizens can confiscate guns from bad citizens.

intelligence - when set high baddies are aware of the proportion of initial legal guns and are less likely to attack citizenss.

demand-for-guns - sets the proportion of citizens that want a gun.

gun-competence-threshold - If the appropriate gun-eligibility-criterion is set the gun-competence of a citizen must be equal to or greater than this threshold for a good-citizen to be able to acquire a gun from a legal gunshop. Any bad citizens can acquire guns from illegal gunshops. 

show-citizen-parameter - agents are colour-coded to reflect the magnitude of various variables. The darker the colour the higher the value of the variable.

police-mean-aggression - how trigger-happy the police are. Note: police never shoot unarmed bad citizens.

legal-gun-availability - sets the number of legal gunshops. Good citizens deposit extra guns here. If legal-gun-availability is greater than the  number of legal guns, the number of legal guns is automatically reset to legal-gun-availability.

illegal-gun-availability - sets the number of illegal gunshops. Bad citizens deposit extra guns here.  If illegal-gun-availability is greater than the  number of illegal guns, the number of illegal guns is automatically reset to illegal-gun-availability.


initial-legal-guns - sets the number of legal guns.

initial-illegal-guns - sets the number of illegal guns

firepower - sets the calibre of the gun. At 100 a single gunshot kills. At 1 it takes 100 shots to kill. At the lower end of this spectrum the "gun" acts more like a knife.

illegal-guns-destroyed - if set police destroy the guns they acquire from bad citizens. Otherwise the guns are deposited at legal gunshops.

gun-eligibility-criterion - sets the conditions under which a _good_ citizen can own a gun.

THINGS TO TRY
-------------
Set the sliders to the following values. Record the non-aggressive-deaths and the number of illegal guns. Now repeat the experiment but set the gun-elegibility-criterion to "both." What do expect to find regarding non-aggressive-deaths and the number of illegal guns? Can you explain the results?
gun-competence-spread	10
no-of-police	0
police-gun-competence	n/a
aggression-spread	10
mean-gun-competence	50
initial-illegal-guns	50
illegal-guns-destroyed?	FALSE
demand-for-guns	100
end-experiment	100
mean-aggression	49
initial-legal-guns	50
show-citizen-parameter	"guns"
aggression-threshold	50
legal-gun-availability	20
no-of-citizens	600
firepower	25
police-aggression-spread	n/a
attack-threshold	n/a
illegal-gun-availability	20
gun-competence-threshold	n/a
police-mean-aggression	n/a
gun-elegibility-criterion	"none"

How should one reduce the homicide rate against law-abiding citizens? Ban legal guns? If you try this and set intelligence to moderate you will see that law-abiding citizens are disadvantaged. Why? On the other hand if you allow just any law-abiding citizen to have a gun, law-abiding citizens are again disadvantaged? Why? A good citizen that is unable or unwilling to use a gun makes the gun potentially more available for bad citizens to use on other citizens. There is a conflict of interest between the good citizen who wants the freedom to own a gun to protect himself or herself but cannot and the state that has the responsibility to protect citizens in general. Should this individual's right to own a gun be curtailed for the greater good?  
 
There are  some important factors that you, the user, representing the state have control over such as the size and competence of the police force and the conditions under which legal guns can be sold.  These are not the only factors there are. After setup there are other very important matters the state has little or no control such as human aggression and demand for guns. Rabbi Jonathon Sacks puts it way. "The more law is inscribed upon our hearts, the less it needs to be policed in the streets." (Ignoring the spiritual is also a kind of single-factor thinking). What could be done to motivate the agents against aggression without violating their independence as agents? Somehow you would need to persuade them without any coercion that non-aggression is the better way. Since the agents are not conscious this is not really open to us. However, we could model this as best we can by giving each agent a variable "openness" which determines how easily the agent can be persuaded into non-aggression and becoming a persuader. We can also allow chance to play a role in determining how successful a particular encounter is. Then, the most coercive thing you would need to do as the user is to take an agent and convert them into a persuader. You can do this by left clicking on an individual. To simplify things in this model police cannot become persuaders.

In doing this you are "playing God" much as God did in giving Moses the Ten Commandments on Mount Sinai.  As great a leader as Moses was, he was still human and flawed. He had murdered an Egyptian and God forbade him from entering the promised land because of a lack of trust in Him (Numbers 20:12). The world had to wait for a better way and it came when the God the Perfect Persuader injected Himself into the world as Jesus. Jesus Christ's greatest act of persuasion came when He died on the cross. He showed that the greatest act of power was not through a gun, but through the powerlessness of death on the cross. This great love-act has melted the hearts of millions and converted them into pursuing change through love rather than power. There is no question that a gun can stop a bad citizen from hurting you - but Jesus stops bad citizens by making them into good citizens. Actually the Jesus way is superior because converted bad citizens can spiritually reproduce good citizens. Jesus does better than eliminating the bad; He produces the good. Of course the Jesus way is not coercive; it depends on the willingness of agents to respond and they may not. For those that do not we still need the State. The Jesus way does not do away with the need for the State.  The Jesus way shows us a better way that will be fully realised in the next life when God's kingdom is fully come. The Jesus way can be activated by simply injecting the Persuader into the model. Then sit back and watch how the Persuader persuades other agents to become persuaders. 

THINGS TO NOTICE
----------------

The steeper the curve in the aggressive-deaths vs non-aggressive-deaths graph, the greater the overall homicide rate. This can be used to guage the effectiveness of your homicide-reducing strategies. Becoming a persuader does not guarantee the agent's personal safety. What it does is help the community become a little safer. Despite persuaders being individually imperfect (becoming a persuader leads to a reduction not an elimination of aggression) having persuaders in the model does reduce the overall homicide rate. 


RELATED MODELS
--------------
MetemorphoGenesis also shows how counter-intuitive phenomena can emerge out of a complex system. In this case the apparent design of metamorphosis as a successful strategy for finding rich but ephemeral food sources emerges quite naturally through evolution - natural selection acting upon inheritable variation. Metamorphosis is written in Starlogo.

Michael D Makowsky argues that history may be a very important factor in crime. His CAMSIM is a very interesting Netlogo model that shows how simulations can integrate theory across disciplines.



CREDITS AND REFERENCES
----------------------
Guns and Moses can be found on my website: www.mikelanderson.com

Special thank-you to Uri Wilensky and his team for Netlogo. See Wilensky, U. (1999). NetLogo. http:// ccl.northwestern.edu/netlogo/. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL. for information and download.




@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7566196 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

blackmarket
false
0
Rectangle -7566196 true true 45 120 255 285
Polygon -7566196 true true 15 120 150 15 285 120

box
false
0
Polygon -7566196 true true 150 285 285 225 285 75 150 135
Polygon -7566196 true true 150 135 15 75 150 15 285 75
Polygon -7566196 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7566196 true true 96 182 108
Circle -7566196 true true 110 127 80
Circle -7566196 true true 110 75 80
Line -7566196 true 150 100 80 30
Line -7566196 true 150 100 220 30

building store
false
0
Rectangle -7566196 true true 30 45 45 240
Rectangle -16777216 false false 30 45 45 165
Rectangle -7566196 true true 15 165 285 255
Rectangle -16777216 true false 120 195 180 255
Line -7566196 true 150 195 150 255
Rectangle -16777216 true false 30 180 105 240
Rectangle -16777216 true false 195 180 270 240
Line -16777216 false 0 165 300 165
Polygon -7566196 true true 0 165 45 135 60 90 240 90 255 135 300 165
Rectangle -7566196 true true 0 0 75 45
Rectangle -16777216 false false 0 0 75 45

butterfly
true
0
Polygon -7566196 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7566196 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7566196 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7566196 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7566196 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7566196 true true 47 195 58
Circle -7566196 true true 195 195 58

circle
false
0
Circle -7566196 true true 30 30 240

circle 2
false
0
Circle -7566196 true true 16 16 270
Circle -16777216 true false 46 46 210

cow
false
0
Polygon -7566196 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7566196 true true 73 210 86 251 62 249 48 208
Polygon -7566196 true true 25 114 16 195 9 204 23 213 25 200 39 123

face happy
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7566196 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7566196 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7566196 true true 60 15 75 300
Polygon -7566196 true true 90 150 270 90 90 30
Line -7566196 true 75 135 90 135
Line -7566196 true 75 45 90 45

flower
false
0
Polygon -11352576 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7566196 true true 85 132 38
Circle -7566196 true true 130 147 38
Circle -7566196 true true 192 85 38
Circle -7566196 true true 85 40 38
Circle -7566196 true true 177 40 38
Circle -7566196 true true 177 132 38
Circle -7566196 true true 70 85 38
Circle -7566196 true true 130 25 38
Circle -7566196 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -11352576 true false 189 233 219 188 249 173 279 188 234 218
Polygon -11352576 true false 180 255 150 210 105 210 75 240 135 240

gunman
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105
Rectangle -16776961 true false 0 150 60 165
Rectangle -16776961 true false 60 180 60 195
Rectangle -16776961 true false 45 165 60 195

gunshop
false
0
Rectangle -7566196 true true 15 165 285 255
Rectangle -7566196 true true 120 195 180 255
Line -7566196 true 150 195 150 255
Rectangle -7566196 true true 30 180 105 240
Rectangle -7566196 true true 195 180 270 240
Line -7566196 true 0 165 300 165
Polygon -7566196 true true 0 165 45 135 60 90 240 90 255 135 300 165

house
false
0
Rectangle -6524078 true false 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -6524078 true false 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7566196 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7566196 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7566196 true 150 0 150 300

nonebaddy
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105
Rectangle -16776961 true false 60 180 60 195

pentagon
false
0
Polygon -7566196 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105

person police
false
0
Polygon -1 true false 124 91 150 165 178 91
Polygon -16776961 true false 134 91 149 106 134 181 149 196 164 181 149 106 164 91
Polygon -16776961 true false 180 195 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285
Polygon -16776961 true false 120 90 105 90 60 195 90 210 116 158 120 195 180 195 184 158 210 210 240 195 195 90 180 90 165 105 150 165 135 105 120 90
Rectangle -7566196 true true 123 76 176 92
Circle -7566196 true true 110 5 80
Polygon -16776961 true false 150 26 110 41 97 29 137 -1 158 6 185 0 201 6 196 23 204 34 180 33
Line -16776961 false 121 90 194 90
Line -16777216 false 148 143 150 196
Rectangle -16777216 true false 116 186 182 198
Rectangle -16777216 true false 109 183 124 227
Rectangle -16777216 true false 176 183 195 205
Circle -1 true false 152 143 9
Circle -1 true false 152 166 9
Polygon -256 true false 172 112 191 112 185 133 179 133
Polygon -256 true false 175 6 194 6 189 21 180 21
Line -256 false 149 24 197 24
Rectangle -16777216 true false 101 177 122 187
Rectangle -16777216 true false 179 164 183 186

plant
false
0
Rectangle -7566196 true true 135 90 165 300
Polygon -7566196 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7566196 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7566196 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7566196 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7566196 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7566196 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7566196 true true 135 90 120 45 150 15 180 45 165 90

skeleton
false
0
Circle -1 true false 120 15 60
Rectangle -1 true false 135 75 165 90
Rectangle -1 true false 45 90 255 105
Rectangle -1 true false 135 105 165 195
Rectangle -1 true false 105 120 195 135
Rectangle -1 true false 105 150 195 165
Rectangle -1 true false 105 180 195 195
Rectangle -1 true false 120 195 135 300
Rectangle -1 true false 165 195 180 300

square
false
0
Rectangle -7566196 true true 30 30 270 270

square 2
false
0
Rectangle -7566196 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7566196 true true 60 270 150 0 240 270 15 105 285 105
Polygon -7566196 true true 75 120 105 210 195 210 225 120 150 75

target
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7566196 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7566196 true true 120 120 60

tree
false
0
Circle -7566196 true true 118 3 94
Rectangle -6524078 true false 120 195 180 300
Circle -7566196 true true 65 21 108
Circle -7566196 true true 116 41 127
Circle -7566196 true true 45 90 120
Circle -7566196 true true 104 74 152

triangle
false
0
Polygon -7566196 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7566196 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7566196 true true 4 45 195 187
Polygon -7566196 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7566196 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7566196 false true 24 174 42
Circle -7566196 false true 144 174 42
Circle -7566196 false true 234 174 42

turtle
true
0
Polygon -11352576 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -11352576 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -11352576 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -11352576 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -11352576 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7566196 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7566196 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7566196 true 150 285 150 15
Line -7566196 true 15 150 285 150
Circle -7566196 true true 120 120 60
Line -7566196 true 216 40 79 269
Line -7566196 true 40 84 269 221
Line -7566196 true 40 216 269 79
Line -7566196 true 84 40 221 269

x
false
0
Polygon -7566196 true true 270 75 225 30 30 225 75 270
Polygon -7566196 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 2.1.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
